\chapter{Interpolation on Manifolds}\label{ch:InterpolationOnManifolds}

As seen in the previous chapters, the eigenvectors of a matrix have many important applications. However, their computation can get very expensive, this is because it takes $O(n^3)$ operations \cite{watkins2008qr}, where $n$ is the size of the matrix. In some cases, the computational effort may be reduced. If the use cases require many computations of the eigenvectors of a matrix $A$ that depend on a parameter $p$, it is possible to instead compute just a few eigenvectors and approximate others by interpolation.

Interpolation is a technique in which you have a set of data points that depend on a parameter. Inside this parameter domain, you can create an interpolation function that can approximate the data points. We will focus on interpolation in one-dimensional parameter domains. Just applying regular interpolation algorithms to eigenvectors will however lead to problems. This is because in general, the interpolated vectors will not be orthogonal. This issue can be resolved by constraining the interpolation to values on manifolds that enforce this orthogonality condition. Depending on the application, special interest is on the exact eigenvectors or on the spanned space by the eigenvectors. This difference between those two problem classes was presented in the chapter about the density operator. If the focus of the applications lies on the eigenvectors, the manifold of choice should be the Stiefel manifold. In cases where the focus is on the spanned space, for example in the energy of the ground state in the density operator formalism, then the Grassmann manifold is preferable. In this chapter, we will focus on the Grassmann manifold, however, the presented algorithms can easily be transferred to the Stiefel manifold.

\section{Interpolation on Manifolds}\label{subsec:InterpolationOnManifolds}
There exist multiple approaches to interpolation on the manifold. In this thesis, we will use interpolation on the tangent space. The interpolation on the tangent space uses the fact that the tangent space spanned at any point on a manifold is a Euclidean plane. This means that we can apply ``classical'' interpolation, for example, polynomial interpolation, on the tangent space and retract the result back to the manifold with the exponential map operation. This guarantees that the interpolated values are on the manifold and therefore the orthogonality constraint will be upheld. A visualization of this can be seen in figure \ref{fig:InterolationMonifoldsFig}. Since we are working with matrix manifolds of size $(n \times p)$, each entry in the matrix will be interpolated independently. Interpolation on the tangent space is described in algorithm \ref{alg:InterpolationOnManifolds}. For more details about this algorithm \ref{alg:interpolationTangentSpace} and alternative approaches, we refer the reader to \cite{zimmermann2019manifold}.

\begin{algorithm}[H]
  \caption{Interpolation on the Tangent Space}\label{alg:interpolationTangentSpace}
  \begin{algorithmic}[1]
    \Require Dataset $V = \{v_1, \dots, v_n\} \subset \mathcal{M}$
    \State Chose a base point $v_i \in V$
    \For j = 1,\dots, n
        \State Compute $\textnormal{Log}_{v_i}(v_j) = w_j \in T_{v_i} \mathcal{M}$
    \EndFor
    \State Compute $w^*$ via Euclidean interpolation between $\{w_1, \cdots, w_n \}$ 
    \State Compute $ v^* = \textnormal{Exp}_{v_i}(w^*) \in \mathcal{M}$
  \end{algorithmic}
  \label{alg:InterpolationOnManifolds}
\end{algorithm}


\begin{figure}[H]
    \begin{center}
        \includegraphics[scale=2.5]{figs/ManifoldInterpolation/ManifoldInterpolation.pdf}
    \caption{This figure shows interpolation on the tangent space $T\mathcal{M}$. The blue points are $v_i \in V \subset M$ and the red points are $w_i = \textnormal{Log}(v_i) \in T\mathcal{M}$. The red dotted line is an interpolation function $f(p):\mathbb{R} \rightarrow T\mathcal{M}$ and the blue dotted line is $\textnormal{Exp}(f(p)):\mathbb{R} \rightarrow \mathcal{M}$.}
    \label{fig:InterolationMonifoldsFig}
    \end{center}
\end{figure}

\subsection{Spline Interpolation}
The first presented interpolation technique involves splines. Splines are piecewise polynomial functions in between interpolation nodes. The degree of the polynomial determines the type of spline, common are linear and cubic splines. Linear splines are easy to compute, however, they are only accurate up to first order. Better, but more expensive are cubic splines. Cubic splines use polynomials of third degree. It should be noted that linear and cubic splines both fulfill the interpolation condition, that is, that the value of the splines at an interpolation node is the exact data value. Bézier curves are also sometimes referred to as splines, however, note that for those the interpolation condition is not always true.

\subsubsection*{Linear Splines}
We will start with the most simple possible splines, the linear splines. Let us denote the operator as $A(p)$ and the computed eigenvectors, also called data points, as $ V = \{v_1, v_2,\dots ,v_k \}$. Each element of $V$ is on the Grassmann manifold $v_i \in Gr(n,p)$. Each data point has a corresponding parameter value $P = \{p_1, p_2, \dots, p_k \}$. For simpler notation, we will assume that  $p_i < p_{i+1} \ \forall \: i$. Linear splines are first degree polynomials of the form $f_i(p) = a_i p + b_i \ \forall \ p \in [p_i, p_{i+1}]$ between two data points  $v_i$ and $v_{i+1}$. Combining all the splines leads to the interpolation function $f(p)$ for the entire parameter domain $[p_1, p_k]$:

\begin{align*}
    f(p) = \begin{cases}
        a_1 \quad p + b_1    \quad & \text{if } p \in [p_1, p_2] \\
        a_2 \quad p + b_2    \quad & \text{if } p \in (p_2, p_3] \\
        \quad \quad \vdots         &\quad \vdots\\
        a_{k-1} p + b_ {k-1} \quad & \text{if } p \in (p_{k-1}, p_k] .
    \end{cases}
\end{align*}

Note that linear splines are not differentiable at the data points. In total $2(k-1)$ coefficients need to be computed in order to construct $f(p)$. The equations for $a_i$ and  $b_i$ come from the interpolation condition $x_i = f(p_i)$:

\begin{align*}
    f_1(p_1) &= v_1 , \\
    f_1(p_2) &= v_2 , \\
    f_2(p_2) &= v_2 , \\
    f_2(p_3) &= v_3 , \\
    &\dots \\
    f_{k-1}(p_{k-1}) &= v_{k-1} ,\\
    f_{k-1}(p_{k}) &= v_{k} .
\end{align*}

An example of linear splines for four data points can be seen in figure \ref{fig:linSplines}.

\begin{figure}[H]
    \begin{center}

        \def\range{9}
        \def\xyRatio{2/3}

        \begin{tikzpicture}
            \begin{axis}[
                xlabel=$p$,
                ylabel=$f(p)$,
                samples=100,
                grid=both,
                minor grid style={gray!25},
                major grid style={gray!25},
                xmin=1.5, xmax=8.5, ymin=0.5, ymax=7.5,
                ]\addplot [only marks] table {
                                                2 3
                                                3 2
                                                6 6
                                                8 4
                                                };                
                \addplot[color=red][domain=2:3]{-1*x + 5};
                \addplot[color=blue][domain=3:6]{1.33333*x -2 };
                \addplot[color=green][domain=6:8]{-1*x + 12};                   
                
            \end{axis}
        \end{tikzpicture}    
    \end{center}
    
    \caption{This figure shows an example of linear splines. The different colors indicate different first order polynomials between the interpolation nodes, which are shown as black dots.}
    \label{fig:linSplines}
\end{figure}

\subsubsection*{Cubic Splines}
Cubic splines are very similar to linear splines, the difference is that they use cubic polynomials of the form $f_i(p) = a_i p^3 + b_i p^2 + c_i p + d_i \ \forall p \in [p_i, p_{i+1}]$. However, cubic splines are computationally more expensive than linear splines, but in return you get greatly improved interpolation function $f(p)$:

\begin{align*}
    f(p) = \begin{cases}
        a_1 \quad p^3 + b_1 \quad \ p^2 + c_1 \quad \ p + d_1 \quad &\text{if } p \in [p_1, p_2] \\
        a_2 \quad p^3 + b_2 \quad \ p^2 + c_2 \quad \ p + d_2 \quad &\text{if } p \in (p_2, p_3] \\
        \quad \quad \vdots  \quad \quad \quad \quad \vdots  \quad \quad \quad \quad \vdots & \quad \vdots\\
        a_{k-1}\ p^3 + b_{k-1} \ p^2 + c_{k-1} \ p + d_{k-1} \quad &\text{if } p \in (p_{k-1}, p_k]
    \end{cases}
\end{align*}

Just like for the linear splines, the coefficients $a_i, b_i, c_i, d_i$ get computed by solving a linear system of equations. But since we now have more coefficients, we need more equations. In total $4(k-1)$ equations are needed. The first $2(k-1)$ are identical to the linear splines:

\begin{align*}
    f_1(p_1) &= v_1 , \\
    f_1(p_2) &= v_2 , \\
    f_2(p_2) &= v_2 , \\
    f_2(p_3) &= v_3 , \\
    &\dots  \\
    f_{k-1}(p_{k-1}) &= v_{k-1} , \\
    f_{k-1}(p_{k}) &= v_{k} .
\end{align*}

Additional equations come from the derivatives at the data points. In order to get smooth transitions at the nodes, the polynomials from the left and right sides should have the same first and second derivative:

\begin{align*}
    \frac{d}{dp}f_1(p_2) &= \frac{d}{dp}f_2(p_2) , \\
    \frac{d}{dp}f_2(p_3) &= \frac{d}{dp}f_3(p_3) , \\
    &\cdots  \\
    \frac{d}{dp}f_{k-2}(p_{k-1}) &= \frac{d}{dp}f_{k-1}(p_{k-1}),
\end{align*}

and 

\begin{align*}
    \frac{d^2}{d^2p}f_1(p_2) &= \frac{d^2}{d^2p}f_2(p_2) ,\\
    \frac{d^2}{d^2p}f_2(p_3) &= \frac{d^2}{d^2p}f_3(p_3) ,\\
    &\cdots  \\
    \frac{d^2}{d^2p}f_{k-2}(p_{k-1}) &= \frac{d^2}{d^2p}f_{k-1}(p_{k-1}) .
\end{align*}

This gives us $2(k-1)-2$ more equations. The last 2 equations come from constraints on the derivatives at the border of the parameter domain. There are multiple choices for those boundary conditions, we will use the so-called natural splines. Natural splines set the second derivative at the boundaries to 0:

\begin{align*}
    6a_1 p_1 + 2b_1 = 0 , \\
    6a_n p_n + 2b_n = 0 . 
\end{align*}

In the figure \ref{fig:IndividualCubicSplines} the individual cubic splines are illustrated. And then in the following figure \ref{fig:CubicSplines}, the assembled interpolation function can be seen.

\begin{figure}[H]  
    \begin{center}
        % \resizebox{\textwidth}{!}{%
        \begin{tikzpicture}[scale=0.60] 
                    \begin{axis}[
                        xlabel=$p$,
                        ylabel=$f(p)$,
                        samples=100,
                        grid=both,
                        minor grid style={gray!25},
                        major grid style={gray!25},
                        xmin=-0.5, xmax=10.5, ymin=0.5, ymax=10.5,
                        ]\addplot [only marks] table {
                                                        2 3
                                                        3 2
                                                        6 6
                                                        8 4
                                                        };                
                        \addplot[color=red][domain=2:3]{+0.4272300469483568*x^3+-2.563380281690141*x^2+3.699530516431925*x^1+2.436619718309859*x^0};
                        \addplot[dashed,scale=0.02,color=red][domain=0:10]{+0.4272300469483568*x^3+-2.563380281690141*x^2+3.699530516431925*x^1+2.436619718309859*x^0};
                    \end{axis}
        \end{tikzpicture}% NO EMPTY LINE HERE!!!!
        \begin{tikzpicture}[scale=0.60] 
                    \begin{axis}[
                        xlabel=$p$,
                        samples=100,
                        grid=both,
                        minor grid style={gray!25},
                        major grid style={gray!25},
                        xmin=-0.5, xmax=10.5, ymin=0.5, ymax=10.5,
                        ]\addplot [only marks] table {
                                                        2 3
                                                        3 2
                                                        6 6
                                                        8 4
                                                        };                
                        \addplot[color=blue][domain=3:6]{+-0.26291079812206575*x^3+3.647887323943662*x^2+-14.934272300469484*x^1+21.070422535211268*x^0};
                        \addplot[dashed,scale=0.02,color=blue][domain=0:10]{+-0.26291079812206575*x^3+3.647887323943662*x^2+-14.934272300469484*x^1+21.070422535211268*x^0};
                    \end{axis}
        \end{tikzpicture}% NO EMPTY LINE HERE!!!! 
        \begin{tikzpicture}[scale=0.60]
                    \begin{axis}[
                        xlabel=$p$,
                        samples=100,
                        grid=both,
                        minor grid style={gray!25},
                        major grid style={gray!25},
                        xmin=-0.5, xmax=10.5, ymin=0.5, ymax=10.5,
                        ]\addplot [only marks] table {
                                                        2 3
                                                        3 2
                                                        6 6
                                                        8 4
                                                        };
                        \addplot[color=green][domain=6:8]{+0.1807511737089202*x^3+-4.338028169014085*x^2+32.98122065727699*x^1+-74.7605633802817*x^0};  
                        \addplot[dashed, scale=0.02, color=green][domain=0:10]{+0.1807511737089202*x^3+-4.338028169014085*x^2+32.98122065727699*x^1+-74.7605633802817*x^0}; 
                    \end{axis}
        \end{tikzpicture}         
                % }
    \end{center}
    \caption{This figure shows third-degree polynomials between the interpolation nodes. The continuous lines represent the interpolation functions inside their parameter domain and the dashed lines are outside their respective range.}
    \label{fig:IndividualCubicSplines}
\end{figure} 

\begin{figure}[H]
    \begin{center}
        \begin{tikzpicture}
            \begin{axis}[
                xlabel=$p$,
                ylabel=$f(p)$,
                samples=100,
                grid=both,
                minor grid style={gray!25},
                major grid style={gray!25},
                xmin=1.5, xmax=8.5, ymin=0.5, ymax=7.5,
                ]\addplot [only marks] table {
                                                2 3
                                                3 2
                                                6 6
                                                8 4
                                                };                
                \addplot[color=red][domain=2:3]{+0.4272300469483568*x^3+-2.563380281690141*x^2+3.699530516431925*x^1+2.436619718309859*x^0};
                \addplot[color=blue][domain=3:6]{+-0.26291079812206575*x^3+3.647887323943662*x^2+-14.934272300469484*x^1+21.070422535211268*x^0};
                \addplot[color=green][domain=6:8]{+0.1807511737089202*x^3+-4.338028169014085*x^2+32.98122065727699*x^1+-74.7605633802817*x^0};                  
                
            \end{axis}
        \end{tikzpicture}
    \end{center}
    \caption{This figure shows the assembled interpolation function consisting of three cubic splines.}
    \label{fig:CubicSplines}
\end{figure}

\subsection{Polynomial Interpolation}
Alternatively, to spline interpolation, polynomial interpolation is a popular choice. In contrast to splines, polynomial interpolation constructs a single polynomial function for the entire parameter domain. An illustration of this can be seen in figure \ref{fig:PolynomialInterpolation}. This is done with a linear combination of scaled orthogonal basis functions  $l_i(p)$. We will use Lagrange basis functions. 

\begin{align*}
    f(p) = \sum_{i=0}^{n} v_i l_i(p) \\
    l_i(p) = \prod_{\substack{0 \leq  m \leq k \\  m \neq  i}} \frac{p - p_m}{p_i -p_m}
\end{align*}

\begin{figure}[H]
    \begin{center}
        \begin{tikzpicture}
            \begin{axis}[
                xlabel=$p$,
                ylabel=$f(p)$,
                samples=100,
                grid=both,
                minor grid style={gray!25},
                major grid style={gray!25},
                xmin=1.5, xmax=8.5, ymin=0.5, ymax=7.5,
                ]\addplot [only marks] table {
                    2 3
                    3 2
                    6 6
                    8 4
                    };                
                    \addplot[][domain=2:8]{+-0.175*x^3+2.5083*x^2+-10.216*x^1+14.8*x^0};
            \end{axis}
        \end{tikzpicture}
    \end{center}
    \caption{This figure shows polynomial interpolation with a fourth-degree polynomial.}
    \label{fig:PolynomialInterpolation}
\end{figure}
    
Polynomial interpolation has one big downside. That is if you have many data points which are equidistantly sampled, strong oscillations occur at the boundary of the domain. This is also called the Runge phenomenon. Therefore, if possible it should be avoided to sample the points equidistant. The optimal sampling nodes are given by the roots of the Chebyshev polynomials. For an interval $[a,b]$ the optimal nodes are given by:
\begin{align*}
    p_i = \frac{1}{2}(a+b) + \frac{1}{2}(b-a)\cos(\frac{2i-1}{2k}\pi), \quad i=1,\dots,k . 
\end{align*}
However, in many applications, it is not applicable to sample points at the Chebyshev nodes. Therefore, both the interpolation at the equidistant and Chebyshev nodes will be investigated.


\section{Convergence Rates}\label{sec:ConvergenceRates}
To test the different interpolation algorithms, a test case is created. We take a square $\in \mathbb{R}^2$, that is discretized and then stretched in one direction. The stretching is done with a simple function $f(p)$ applied to all the nodes on the mesh. An example of the transformation of the mesh can be seen in figure \ref{fig:SquareMeshTransformation}.

\begin{figure}[H]
    \begin{tikzpicture}[]
    \node[inner sep=0pt,scale=.228] (T1) at (0,0) {\includegraphics[width=1\textwidth]{figs/square.png}};
        \node[inner sep=0pt,scale=.33] (T2) at (8,0) {\includegraphics[width=1\textwidth]{figs/squareStreched.png}};

        \draw[->, very thick] (2.1,0) -- (5,0);
        \node at (3.5,0.5) {$f(1.5)$};
    \end{tikzpicture}
    \caption{This figure shows the transformation operator $f(p)$ applied on the square grid with the parameter $1.5$. This results in a stretching of $150\%$ in $x$-direction.}
    \label{fig:SquareMeshTransformation}
\end{figure}

After the mesh gets transformed, it can be interpreted as a graph and the Laplace matrix of this graph then gets constructed. How to interpret a mesh as a graph will be shown in section \ref{sec:LaplaceOperatorOnGraphs}. For the testing procedure, we will discretize the parameter domain $[0.2,3]$ in steps with size 0.001. Then, we will choose the interpolation nodes. For the splines and the equidistant polynomial interpolation, we simply chose the interpolation nodes equidistant. For the Chebyshev nodes, we chose the closest points corresponding to the actual root. An illustration of this can be seen in figure \ref{fig:ErrorCalculation}. As for the error, we compute the error at every grid point and sum them all together.



There are two types of errors we can compute, first, there is the Frobenius Norm of the corresponding density matrix:
\begin{align*}
    \|U_{\textnormal{ap}}^{} U_{\textnormal{ap}}^T - U_{\text{ex}}^{} U_{\text{ex}}^T\|_F,
\end{align*}
 which can be interpreted as a sort of Euclidean distance norm. An alternative to that is a subspace angle norm, where the angle between the spanned spaces will be compared. Let $USV = U_{\text{ap}}^T U_{\text{ex}}$ be an SVD decomposition, then the angle is given by 
\begin{align*} 
    \text{norm}(\text{Re}(b)) \quad \text{ where } b_i \ =\ \begin{cases}
        0  & \text{if} \;S_i \; \geq \;1 \\
        \arccos(S_i) \quad & \text{if}\; S_i \; < \; 1
    \end{cases}
\end{align*}

\begin{figure}[H]
    \centering
    \includegraphics[scale=0.75]{figs/ErrorInterpolation/ErrorInterpolation.pdf}
    \caption{This figure shows how the error between the interpolation function and the real density matrices is computed. The interpolation function is shown symbolically in red and the real density matrices for each value in the parameter space are symbolically shown in blue. The interpolation function was constructed with the values shown by the black dots and bigger ticks at the x-axis. The distance between the interpolated density matrix and analytically computed density matrix was measured in either the Frobenius norm or subspace angle norm at each of the evaluation points which are shown by smaller ticks at the x-axis. All these distances are summed up. This was repeated for a different number of interpolation nodes, but the number of evaluation points stayed the same.}
    \label{fig:ErrorCalculation}
\end{figure}

\begin{figure}[H]
\begin{center}
    \begin{tikzpicture}[]
        \pgfplotstableread[col sep = comma]{./figs/export_frobenius.csv}\mydata
        \begin{axis}[
            ymode=log,
            xmode=log,
            xlabel=Number Interpolation Nodes,
            ylabel=Error,
            title={Frobenius Norm},
            grid=both,
            minor grid style={gray!25},
            major grid style={gray!25},
            width=0.75\linewidth,
            legend columns=2,
            legend to name=named,
            scale=0.6
            ]    
            \addplot table[x index = {0}, y index = {2}]{\mydata};
            \addlegendentry{Linear Splines}
            \addplot table[x index = {0}, y index = {3}]{\mydata};
            \addlegendentry{Cubic Splines}
            \addplot table[x index = {0}, y index = {1}]{\mydata};
            \addlegendentry{Lagrange at Chebyshev Nodes}
            \addplot table[x index = {0}, y index = {4}]{\mydata};
            \addlegendentry{Lagrange evenly spaced Grid}
        \end{axis}
    \end{tikzpicture}
    %
    \begin{tikzpicture}
        \pgfplotstableread[col sep = comma]{./figs/export_angle.csv}\mydata
        \begin{axis}[
            ymode=log,
            xmode=log,
            xlabel=Number Interpolation Nodes,
            title={Subspace Angle Norm},
    grid=both,
    minor grid style={gray!25},
    major grid style={gray!25},
    width=0.75\linewidth,
    legend columns=2,
    scale=0.6
    ]
    \addplot table[x index = {0}, y index = {2}]{\mydata};
    \addplot table[x index = {0}, y index = {3}]{\mydata};
    \addplot table[x index = {0}, y index = {1}]{\mydata};
    \addplot table[x index = {0}, y index = {4}]{\mydata};
\end{axis}
\end{tikzpicture}
\ref{named}
\end{center}
\caption{This figure shows convergence rates of different interpolation algorithms applied on the tangent space of the Grassmann manifold. The error was measured in the Frobenius norm and the subspace angle norm. The subspace angle norm flattens out at $10^{-4}$, our guess is that the SVD used for the computation is not accurate enough to resolve the error finer.}
\label{fig:ConvergenceRates}
\end{figure}

As seen in figure \ref{fig:ConvergenceRates}, the Lagrange interpolation at the Chebyshev nodes converges the fastest. Lagrange interpolation on an equidistant grid starts with the same convergence rate, however, as soon as the Runge oscillations start, the interpolation results are unusable. The splines behave as expected. Linear splines converge slower than the more expensive cubic splines. Comparing the cubic splines to the Lagrange interpolation on the Chebyshev nodes, Lagrange converges significantly faster. However, the interpolation on Chebyshev nodes is not applicable in all use cases as mentioned before.

\section{Safety Margins}
A problem that can occur when interpolating eigenvectors is eigenvalue crossing.
Generally, the interest lies in the $k$ eigenvectors associated with the $k$ smallest or biggest eigenvalues. We will focus on the $k$ the smallest eigenvalues with their corresponding eigenvectors. Assume we have a parameter dependent operator $A(p)$ and $p_i < p_{i+1}$. An eigenvalue crossing occurs, when the order of the eigenvectors changes from $p_i$ to $p_{i+1}$. This happens, because the magnitude of the eigenvalues changes. In other words, the energy of an eigenvector changes such that it is lower or higher for $A(p_{i+1})$ than it was for $A(p_i)$. Therefore, it changes its position in eigenvector order. This is an issue, because, the interpolation between $A(p_i)$ and $A(p_{i+1})$ will yield bad results. Let $v_i$ be an eigenvector and $\lambda_i$ the associated eigenvalue. Furthermore, let $\lambda_i < \lambda_{i+1}$ for $A(p_i)$ and $\lambda_i > \lambda_{i+1}$ for $A(p_{i+1})$. As you can see, a crossing of the $i$ and $i+1$ eigenvalues occurs between $p_i$ and $p_{i+1}$. The implication for the interpolation is the following: instead of getting interpolation functions $f_i(p)$ for $v_i$ and $f_{i+1}(p)$ for $v_{i+1}$, $f_i(p)$ and $f_{i+1}(p)$ interpolate a basis function of the space spanned by $\textnormal{span}(v_i,v_{i+1})$. When trying to interpolate for the exact eigenvectors on the Stiefel manifold, this is already problematic. However, when interested in the eigenspace spanned by the first $k$ eigenvectors, this is not a problem if $i+1 < k$, because the spanned space stays the same. When $i = k$, this becomes an issue, because you are interpolating half of $\text{span}(v_i,v_{i+1})$. This means you are ``losing'' half of the eigenspace because $i+1$ does not get interpolated, which leads to big interpolation errors between $p_i$ and $p_{i+1}$.

The operator on the square introduced in the section \ref{sec:ConvergenceRates} about convergence rates was used here again in order to demonstrate the eigenvalue crossing. An example of the resulting interpolation error can be seen in figure \ref{fig:InterpolationCrossing} and an example of a crossing can be seen in figure \ref{fig:crossing}. 

\begin{figure}[H]
    \begin{center}
        \resizebox{\textwidth}{!}{%
        \begin{tikzpicture}[spy using outlines= {circle, magnification=3, connect spies}]

            \definecolor{color1}{HTML}{009900};
            \pgfplotstableread[col sep = comma]{./figs/crossingError.csv}\dataError
            \pgfplotstableread[col sep = comma]{./figs/crossingErrorInterpolationNodes.csv}\dataNodes
            \pgfplotstableread[col sep = comma]{./figs/crossingErrorEigenvalues.csv}\dataEigenValues

                \begin{axis}[
                    ylabel=$\|U_{\textnormal{ap}}^{}U_{\textnormal{ap}}^T - U_{\text{ex}}^{}U_{\text{ex}}^T\|_F$,
                    yticklabel style={
                        /pgf/number format/fixed,
                        /pgf/number format/precision=3
                        },
                    xticklabels={draw=none},
                    grid=both,
                    minor grid style={gray!25},
                    major grid style={gray!25},
                    width=15cm,height=5cm,
                    name=main plot,
                    line join=round,
                    ]    
                    \addplot[line width=2pt, mark size=2pt] table[x index = {0}, y index = {1}]{\dataError};
                    \addlegendentry{Interpolation Error} 
                    \addplot[only marks, color = blue, mark size=2pt] table[x index = {0}, y index = {1}]{\dataNodes};
                    \addlegendentry{Interpolation Nodes}
                \end{axis}

                \begin{axis}[
                    xlabel=Parameter Space,
                    ylabel=Eigenvalues,
                    yticklabel style={
                        /pgf/number format/fixed,
                        /pgf/number format/precision=3
                        },
                    grid=both,
                    minor grid style={gray!25},
                    major grid style={gray!25},
                    width=15cm,height=7cm,
                    at={(main plot.below south west)},
                        anchor=north west,    
                        % yshift=-0.1ex,        
                    ]    
                    \addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {1}]{\dataEigenValues};
                    \addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {2}]{\dataEigenValues};
                    \addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {3}]{\dataEigenValues};
                    \addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {4}]{\dataEigenValues};
                    \addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {5}]{\dataEigenValues};
                    \addplot[color=color1, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {6}]{\dataEigenValues};
                    \addplot[color=red, line width=1pt, mark size=1pt, ] table[x index = {0}, y index = {7}]{\dataEigenValues};
                    \coordinate (spypoint) at (axis cs: 0.84, 0.085);
                    \coordinate (magnifyglass) at (axis cs: 0.5,0.15);
                \end{axis}

            \spy [black, size=2.5cm] on (spypoint) in node[fill=white] at (magnifyglass);
        \end{tikzpicture}
        }
    \end{center}
    \caption{The graphic above shows an eigenvalue crossing and the resulting error spike. The top plot shows the interpolation error in black and the interpolation nodes in blue. The error spike is between the 0.8 and 1.0 interpolation nodes. The used interpolation function interpolates the first six eigenvectors. The lower plot shows the first six eigenvalues that are interpolated in green and the seventh, which gets not interpolated in red. Tracing a line down from the error spike to the eigenvalues, we can see that we have an eigenvalue crossing at around 0.84.}
    \label{fig:InterpolationCrossing}
\end{figure}

A possible way to resolve this issue will now be presented. The approach we take includes the use of a safety margin. The core idea is to interpolate on a bigger space, instead of on $Gr(n,k)$, we now interpolate on $Gr(n,k+s)$, where $s \in \mathbb{N^+}$ is the size of the safety margin. The bigger space gives us to use additional information which we can use to get a better approximation of the eigenvectors. On the bigger space, interpolation will be done as outlined in the previous sections with an interpolation algorithm of choice. Later, in a post-processing step, the additional eigenvectors will be used to construct a new space in which a subspace problem is solved to determine the right eigenvector order. This algorithm is detailed in algorithm \ref{alg:crossing}. The solution to an eigenvalue problem on a smaller subspace is also called the Rayleigh-Ritz method\cite{bai2000templates}. It should be noted that if an eigenvector crosses more than $s$ other eigenvectors, this algorithm is not able to deliver the right result. We are currently unaware of any a-priory guess for the safety margin size $s$.

\begin{algorithm}[H]
    \caption{Crossing Correcting Algorithm}\label{alg:crossing} 
    \begin{flushleft}
        \hspace*{\algorithmicindent} \textbf{Input:}  Evaluation point $p^* \in \mathbb{R}$ \\
        \hspace*{\algorithmicindent} \textbf{Require:} $n > k + s$, Interpolation function $f(p) \rightarrow \mathbb{R}^{n \times (k+s)}$, Matrix $A \in \mathbb{R}^{n \times n}$ \\ 
    \end{flushleft}

    \begin{algorithmic}[1]
        \State Evaluate $f(p^*) = w^* \in T\mathcal{M}$ and retract the result to the manifold: \par $\text{Retr}(w^*) = v^* \in \mathcal{M} \subset \mathbb{R}^{n \times (k+s)}$.
        \State Project $A$ to the subspace spanned by $v^* \in \mathbb{R}^{n \times (k+s)}$: \par  $(v^*)^T A v^* = A^* \in \mathbb{R}^{(k+s) \times (k+s)}$.
        \State Solve for $k+s$ eigenvalues and corresponding eigenvectors in the reduced space: \par  $A^* x_i =  \lambda_i x_i$, where $x_i \in \mathbb{R}^{k+s}$.
        \State Reconstruct the eigenvectors in the full space: \par $ v^* x_i = \widetilde{x}_i \in \mathbb{R}^{n} \ \forall i \in \{1, \dots, k\}$.
    \end{algorithmic}

    \begin{flushleft}
        \hspace*{\algorithmicindent} \textbf{Return:}  $k$ eigenvectors $\widetilde{x}_i$ corresponding to the $k$ the smallest eigenvalues $\lambda_i$
    \end{flushleft}
\end{algorithm}

The use of this crossing correcting algorithm is of course not free. The additional cost comes from the fact that due to the safety margin, more computations and memory are needed. First, $s$ more analytical eigenvectors need to be computed. Second, the interpolation becomes more expensive because more coefficients need to be saved and computed. Third, the exponential and logarithmic maps become more expensive because they require an SVD, which scales with the size of the matrix. Lastly, the crossing algorithm requires the solution of a smaller eigenvalue problem for each evaluation of the interpolation function. However, this additional eigenvalue decomposition is in cases where $k+s < n$ is still very cheap compared to the computation of the eigenvectors of the full matrix. This is because the complexity of a full eigenvalue decomposition is $O(n^3)$ \cite{watkins2008qr} and $O((k+s)^3)$ for the reduced one.

\begin{figure}[H]
    \begin{center}
        \includegraphics[scale=1.2]{figs/Crossing/Crossing.pdf}
        \caption{This figure shows an example of an eigenvalue crossing. You can see the eighth, ninth, and tenth eigenvectors of a square and the same square stretched by a factor of 1.2 in the y-direction. Between those two states, a crossing of the ninth and tenth eigenvalues occurs. For reference, the eighth eigenvector is included, which does not cross. As you can see, the general structure of the eigenvectors stays the same even for different parameters. An example of this can be seen in the tenth eigenvector at 1.0 and the ninth eigenvector at 1.2. Starting from the top edge, 4 "stripes" go down to the lower edge.}
        \label{fig:crossing}
    \end{center}
\end{figure}

\section{Laplace Operator on Graphs}\label{sec:LaplaceOperatorOnGraphs}
In the chapter \ref{ch:densityOperator} introducing the density operator, we saw that the Laplace operator plays an important role in the description of a quantum system. Remember that the general form of the Hamiltonian can be written as $H = -\Delta + V$, where $V$ is a potential and $-\Delta$ is the kinetic energy. Therefore, the investigation of the Laplace operator is important for every quantum system. In this section, we will investigate how we can apply the manifold interpolation in order to decrease the computation time of the eigenvectors of the Laplace operator. We will apply the Laplace operator on graphs, which are a generalization of a discretized Euclidean domain.

Graph theory is a well-researched field of mathematics and computer science. It deals with structures called graphs, which consist of nodes (also called vertices or points) whose relations are modeled with edges. Graphs are often used to model networks and interactions. We define a graph as pair $(\mathcal{V} , \mathcal{E})$, where $\mathcal{V} = \{V_1,...,V_n\}$ is a set of nodes and $\mathcal{E} \subseteq \mathcal{V} \times \mathcal{V}$ is a set of pairs of two vertices. You can distinguish between two classes of graphs, undirected and directed. Undirected graphs imply that if $(j,i) \in \mathcal{E}$ is an edge  then $(j,i) \in \mathcal{E}$ is also an edge. This is not necessarily the case with directed graphs. Additional, each node has a weight $a_i \in  \mathbb{R} > 0$ and each edge has a weight $w_{i,j} \in  \mathbb{R}$. Graphs can be used to describe Euclidean structures like 3D meshes in animation, but they can also be used for the modeling of non-Euclidean geometries like social networks. The source for this section is \cite{bronstein2017geometric}

\usetikzlibrary{arrows.meta}
\begin{figure}[H]
    \begin{center}
        \begin{tikzpicture}
            \begin{scope}[every node/.style={circle,thick,draw}]
                \node (A) at (0,0) {A};
                \node (B) at (4,2) {B};
            \node (C) at (-3,.2) {C};
            \node (D) at (-1,1.5) {D};
        \end{scope}

        \begin{scope}[>={Stealth[black]}, every node/.style={fill=white,circle}, every edge/.style={draw=black,very thick}]
            \path [] (D) edge[bend right=10] node {$w_{B,D}$} (B);
            \path [] (B) edge[bend right=50] node {$w_{B,C}$} (C);
            \path [] (B) edge[bend left=50] node {$w_{B,A}$} (A);
            \path [] (A) edge[bend left=10] node {$w_{A,C}$} (C);
        \end{scope}

        \end{tikzpicture}    
    \end{center}
    
    \caption{This figure shows an undirected graph with nodes $\mathcal{V} = \{A,B,C,D\}$ and edges $\mathcal{E} = \{(A,B), (A,C), (B,C), (B,D)\}$ with weights $w_{i,j}$.}
    \label{fig:graph}

\end{figure}


% \subsection{Adjacency  and Degree Matrix} 
The adjacency matrix $A \in \mathbb{R}^{n \times n}$ is a square matrix, whose elements indicate an edge between nodes. For unweighted graphs, the entries are either 0 or 1 and for weighted graphs, the entries can be any weight $ w \in \mathbb{R}$. If the graph is undirected, then $A$ is a symmetric matrix.

It is defined as:
\begin{align*}
    A := \begin{cases}
        w_{ij}  & \text{if } e_{i,j} \in \mathcal{E}, \\
        0       & \text{else} .
    \end{cases}
\end{align*}

For the example graph shown in figure \ref{fig:graph}, the adjacency matrix looks like this:

\begin{align*}
    A = 
    \begin{bmatrix}
    0 & w_{ab} & w_{ac} & 0 \\
    w_{ab} & 0 & w_{bc} & w_{bd} \\
    w_{ac} &  w_{bc} & 0 & 0 \\
    0 & w_{bd} & 0 & 0 
    \end{bmatrix} .
\end{align*}

The degree matrix is a diagonal matrix. Its entries are the sums of the edge weights of the connected edges to the corresponding node. This means that in general the degree matrix can be constructed in the following way:
\begin{align*}
    D := \begin{dcases}
        \sum_{i}A_{i,j}  & \text{if } i=j, \\
        0       & \text{else} .
    \end{dcases}
\end{align*}

For the example graph the degree matrix looks like this:
\begin{align*}
    D = 
    \begin{bmatrix}
    w_{ab}+w_{ac} & 0 & 0 & 0 \\
    0 & w_{ab}+w_{bc}+w_{bd} & 0 & 0 \\
    0 & 0 & w_{ac}+w_{bc} & 0 \\
    0 & 0 & 0 & w_{bd} 
    \end{bmatrix} .
\end{align*}

Now with the degree and weight matrix, the Laplace matrix $L$ can be constructed:
\begin{equation}
    L = D - A .
\end{equation}

For our example, $L$ is given by:
\begin{align*}
    L = 
    \begin{bmatrix}
    w_{ab}+w_{ac} & -w_{ab} & -w_{ac} & 0 \\
    -w_{ab} & w_{ab}+w_{bc}+w_{bd} & -w_{bc} & -w_{bd} \\
    -w_{ac} &  -w_{bc} & w_{ac}+w_{bc} & 0 \\
    0 & -w_{bd} & 0 & w_{bd} 
    \end{bmatrix} .
\end{align*}

If you are familiar with finite differences, the structure of $L$ may seem familiar to you. This is because it looks like the negative Laplace operator is discretized by finite differences with free or 0 Neumann boundary conditions. So in general, the Laplace operator is the difference between the average local function values and the function value at the node itself. The eigenfunctions of the graph Laplacian have an intuitive interpretation. The eigenfunctions form an orthonormal basis, where the order of the eigenfunctions is given by the smoothness of the functions. The first eigenfunction will always be constant. The first interesting eigenfunction is the one corresponding to the second-lowest eigenvalue. It divides the domain into two equally sized parts. For higher eigenvalues, the eigenfunction emphasizes certain features of the dataset. Very visual examples are the eigenfunctions of the Laplace operator applied to a mesh of a person as seen in figure \ref{fig:interpretationEigenfunctions}.

A mesh, also called polygon mesh, is an object that is common in computer graphics. A close-up view of a mesh can be seen in figure \ref{fig:meshView}. It generally consists of vertices, edges, and faces and is used to represent 3D objects. Vertices are connected by edges. Those edges have an edge weight, which corresponds to the Euclidean distance between the two vertices it connects. Three edges construct a triangle face. For our use case, we can ignore the faces and just work with the edges and vertices. This is because we can interpret the vertices as graph nodes and the mesh edges with their corresponding weights as edges on a graph.

\begin{figure}[H]
    \centering
    \includegraphics[width=1\textwidth]{figs/eigenfunctions_interpretation.png}
    \caption{From left to right: first to fifth eigenfunctions of the Laplace operator applied to a mesh of a person walking. The first eigenfunction is constant, the second splits the person into left and right. The fourth eigenfunction distinguishes between the left and right leg and so forth.}
    \label{fig:interpretationEigenfunctions}
\end{figure}

The eigenvectors of the Laplace matrix have many applications. The main two are spectral clustering and the graph partitioning. In spectral clustering, the similarities between two nodes are modeled with the weight between those nodes. If you assume that your data has $k$-cluster, you need eigenvectors corresponding to the $k$-smallest eigenvalues of the Laplace matrix. For more information on spectral clustering, you can read the two classics of this field: \cite{fiedler1973algebraic} and \cite{donath2003lower}. The other big application with many use cases is spectral graph partitioning. Graph partitioning is the task of splitting a graph into multiple smaller independent graphs, thereby reducing the problems on the big graph into multiple smaller ones. Graph partitioning can be applied to a wide range of problems. For more information we refer to the papers \cite{hendrickson1995improved} and \cite{bulucc2016recent}.

The eigenfunctions of graphs have also a more general use case. For non-Euclidean domains, the eigenfunctions can replace the Fourier bases for spectral analysis. This allows the solution of partial differential equations on non-Euclidean domains. One example would be the heat equation, whereas in an n-dimension Euclidean domain you could compute the Fourier transformation, on a manifold you need to compute the eigenfunctions of the graph. For a more in-depth dive into functions on graphs, I can recommend the paper \cite{bronstein2017geometric}.


\section{Application on a 3D Mesh}
In this section, an application of eigenvector interpolation is presented. Many shape segmentation algorithms use the eigenvectors of the Laplace operator applied on a mesh. Often the algorithms focus on the segmentation of an object at a single time point, because the computation of the eigenvectors, especially for finer meshes is expensive. Interpolation of the spectrum between time steps offers a cheap way to apply these algorithms to a sequence of meshes. An example of this would be a video or animation.

We will present the application of the eigenvector interpolation on a mesh modeling a jumping Spider-Man. The original mesh can be found at \cite{tinybros}, the version used in this section however had to be modified. This is because in the original mesh, the model is made up of many smaller parts and this would lead to an unconnected graph. The eigenvectors of the Laplace operator applied on unconnected graphs are undesirable. For example, eigenvectors which are 1 on an isolated node and 0 everywhere else. After the modifications, the mesh consists of 11027 vertices and 22112 edges. A close-up view of the mesh can be seen in Figure \ref{fig:meshView}.
\begin{figure}[H]
    \centering
        \begin{tikzpicture}[spy using outlines= {circle, magnification=3, connect spies}]
            \node[inner sep=0pt] (tmp) at (0,0) {\includegraphics[scale=0.15]{figs/mesh_view.png}};
            \coordinate (spypoint) at (-2.9, -0.15);
            \coordinate (magnifyglass) at (-7,2.5);
            \spy [black, size=5cm] on (spypoint) in node[fill=white] at (magnifyglass);
        \end{tikzpicture}
    \caption{This figure shows the used mesh. The mesh is made up of 11027 vertices and 22112 edges. In the close-up view, the edges and nodes from which the mesh is constructed are clearly visible.}
    \label{fig:meshView}
\end{figure}
For the application, the mesh was animated. Animation describes the process, in which the state of the mesh or graph is changed in each time step. This means that for each time step, we have a slightly different graph in which the positions of the vertices have changed. By changing the positions of the vertices, we also change the edge weights, since they describe the distance between the two vertices. The resulting animation can be seen in figure \ref{fig:animatedMesh}. For the first and last state of the mesh, the eigenvectors were computed analytically. Then for the time steps in between the first and last state, the eigenvectors were interpolated using the interpolation on manifolds technique as presented in section \ref{subsec:InterpolationOnManifolds}. The interpolation algorithm does not matter in this case. This is because for just two interpolation nodes, the linear, cubic, and polynomial interpolation yield the same result.
\begin{figure}[H]
    \centering
        \resizebox{\textwidth}{!}{%
        \begin{tikzpicture}
            \node[inner sep=0pt,scale=.21] (T1) at (0,-0.2) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=0.png}};
            % \node[inner sep=0pt,scale=.2] (T2) at (-2.5,0) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=2.png}};
            \node[inner sep=0pt,scale=.19] (T3) at (3,0) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=4.png}};
            \node[inner sep=0pt,scale=.20] (T4) at (6,0.3) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=6.png}};
            \node[inner sep=0pt,scale=.21] (T5) at (9,0.6) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=8.png}};
            \node[inner sep=0pt,scale=.23] (T6) at (12,0.7) {\includegraphics[width=1\textwidth]{figs/SpiderManRender/t=10.png}};
    
            \draw[-stealth,line width= 1.5pt] (0,-3) to (12,-3);
            \draw (5.5,-2.5) node[] {Time};
        \end{tikzpicture}
        }
        \caption{This figure shows the mesh at different time points. A texture is applied, however internally the mesh still consists of vertices and edges.}
        \label{fig:animatedMesh}
\end{figure}

\begin{figure}[H]
    \centering
    \resizebox{\textwidth}{!}{%
    \begin{tikzpicture}
        % SPIDER PLOT
        \node[inner sep=0pt,scale=1] (T1) at (0,0) {\includegraphics[width=1\textwidth]{figs/5th_eigenfunction-.png}};

        % ERROR PLOT
        \pgfplotstableread[col sep = comma]{./figs/errorSpiderPlot.csv}\mydata
        \begin{axis}[
            xlabel={time point},
            ylabel={$\|U_{\textnormal{ap}}^{} U_{\textnormal{ap}}^T - U_{\text{ex}}^{} U_{\text{ex}}^T\|_F$},
            grid=both,
            minor grid style={gray!25},
            major grid style={gray!25},
            width=1.05\linewidth,
            height=3cm,
            at={(-0.5\linewidth,-4cm)}
            ]    
            \addplot table[x index = {0}, y index = {1}]{\mydata};
        \end{axis}
    \end{tikzpicture}
    }

    \caption{This figure shows the result of the eigenvector interpolation. As an example, the sixth eigenvector is presented. With this eigenfunction, we can track the right arm of Spider-Man through the whole parameter domain. The plot on the lower half of the figure shows the interpolation error for each time point.}
    \label{fig:resultInterpolationMesh}
\end{figure}
The interpolation delivered the desired result as seen in figure \ref{fig:resultInterpolationMesh}. The eigenvectors can be traced through the parameter space. This allows the tracking of, for example, the right arm. Algorithms that depend on the eigenvectors of the Laplace matrix can get cheap eigenvectors when using this method.

\section{Implementation and Reproduction}
The data presented in this thesis was generated using the Julia programming language. The Grassmann manifold as well as the implementations of the exponential and logarithmic maps can be found in the ``Manifold.jl'' package \cite{manifold.jl}. An implementation of algorithm \ref{alg:interpolationTangentSpace} can be found in the self-written ``ManifoldInterpolation.jl'' package \cite{berger-stefan}. The used code as well as the used meshes can be found in the Gitlab repository \cite{berger-stefan} in the ``code'' folder.